#include "db.h"

int usage(int);

int process(struct datdb*, char *, char *);

int access(struct datdb*, char*, char*);

int
main(int argc, char* argv[]){
	FILE *diskfile;
	struct datdb *data;
	int quit=0;
	int err=0;
	char command[20];
	char operand[20];
	int flag_changed=0;

	if(argc<3)
		return usage(1);

	if(argc>3)
		return usage(2);

	if( (strcmp(argv[1], "-o")) && (strcmp(argv[1], "-n")) )
		return usage(3);

	if( (data=malloc(sizeof(struct datdb))) == NULL ) {
		fprintf(stderr, "malloc error\n");
	}
	

	if( !(strcmp(argv[1], "-o")) ){
		data->filename[0]=NULL;
		if( (strlen(argv[2])) < 20 ) {
			strncat(data->filename, argv[2], 20);
		} else {
			free(data);
			return usage(4);
		}
		if( (diskfile=fopen(data->filename, "rb")) == NULL ) {
			fprintf(stderr, "file not found!\n");
			return 255;
		}
		data->diskfile=diskfile;
		fread(data, sizeof(struct datdb), 1, diskfile);
		fclose(diskfile);
		printf("%s %s %s %s\n", data->keys[0], data->keys[1], data->keys[2], data->keys[3]);
	} else {
		data->filename[0]=NULL;	
		data->keys_set=0;
		if( (strlen(argv[2])) < 20 ) {
			strncat(data->filename, argv[2], 20);
		} else {
			free(data);
			return usage(4);
		}
		if( (diskfile=fopen(data->filename, "w+b")) == NULL ) {
			fprintf(stderr, "file creat failed\n");
			return 255;
		}
		data->diskfile=diskfile;
		printf("file initialised for writing new datdb %s\n", data->filename);
		 	
	}
	while(!quit){
		printf("%% ");
		gets(command);
		if( (strcmp(command, "quit-save")) == 0 ){
			if(flag_changed){
				data->diskfile=fopen(data->filename, "w+b");
				fwrite(data, sizeof(struct datdb), 1, data->diskfile);	
				fclose(data->diskfile);
			}
			quit=1;
		} 
		else if( (strcmp(command, "quit-nosave")) == 0 ){
			quit=1; 
		} else {
			if (data->keys_set < 4){
				printf("command to set %s for setkeyb..a b c d\n", command);
				printf("enter operand: ");
				gets(operand);
				printf("parralax out %s %s \n", command, operand);
				if( err=process(data, command, operand) ){
					fprintf(stderr, "keys broken order dat a - d\n");
					quit=1;
				} else {
					flag_changed=0;
				}
			} else {
				printf("command issued as key %s\n", command);
				printf("now enter operative edit or dump: ");
				gets(operand);
				printf("parralax out %s %s\n", command, operand);
				if( (strcmp(operand, "edit")) == 0 )
					flag_changed=1;
				err=access(data, command, operand);
			}
		}
	}	
	free(data);
	return 0;
}

int
usage(int check){
	switch(check){
		case 1:
			fprintf(stderr, "not enough arguments\n");
			break;
		case 2:
			fprintf(stderr, "too many arguments\n");
			break;
		case 3:
			fprintf(stderr, "flag not recognised\n");
			break;
		default:
			fprintf(stderr, "unknown error\n");
	}
	printf("usage: datdb [-o open exists -n open created new] [ filename less ext ]\n");
	return check;
}



int 
process(struct datdb *dat, char *com, char *oper){
	int err=0;

	if( (strcmp(com, "setkeya")) == 0){
		strncpy(dat->keys[0], oper, 20);
		if(dat->keys_set==0)dat->keys_set++;
		else err=1;
	} 
	if( (strcmp(com, "setkeyb")) == 0){
		strncpy(dat->keys[1], oper, 20);
		if(dat->keys_set==1)dat->keys_set++;
		else err=1;
	} 
	if( (strcmp(com, "setkeyc")) == 0){
		strncpy(dat->keys[2], oper, 20);
		if(dat->keys_set==2)dat->keys_set++;
		else err=1;
	} 
	if( (strcmp(com, "setkeyd")) == 0){
		strncpy(dat->keys[3], oper, 20);
		if(dat->keys_set==3)dat->keys_set++;
		else err=1;
	} 
	return err;
}



int
access(struct datdb* dat, char *com, char *oper){
	int line;
	char editable[2048];

	if( (strcmp(com, dat->keys[0])) == 0 ){
		if( (strcmp(oper, "dump")) == 0 ){
			for(line=0; line<12; line++)
				printf("%s\n", dat->dat_a[line]);
		}
		if( (strcmp(oper, "edit")) == 0 ){
			for(line=0; line<12; line++) {
				gets(editable);
				strncpy(dat->dat_a[line], editable, 2046);
			}
		}		
	}
	if( (strcmp(com, dat->keys[1])) == 0 ){
		if( (strcmp(oper, "dump")) == 0 ){
			for(line=0; line<12; line++)
				printf("%s\n", dat->dat_b[line]);
		}
		if( (strcmp(oper, "edit")) == 0 ){
			for(line=0; line<12; line++) {
				gets(editable);
				strncpy(dat->dat_b[line], editable, 2046);
			}
		}		
	}
	if( (strcmp(com, dat->keys[2])) == 0 ){
		if( (strcmp(oper, "dump")) == 0 ){
			for(line=0; line<12; line++)
				printf("%s\n", dat->dat_c[line]);
		}
		if( (strcmp(oper, "edit")) == 0 ){
			for(line=0; line<12; line++) {
				gets(editable);
				strncpy(dat->dat_c[line], editable, 2046);
			}
		}		
	}
	if( (strcmp(com, dat->keys[3])) == 0 ){
		if( (strcmp(oper, "dump")) == 0 ){
			for(line=0; line<12; line++)
				printf("%s\n", dat->dat_d[line]);
		} 
		if( (strcmp(oper, "edit")) == 0 ){
			for(line=0; line<12; line++) {
				gets(editable);
				strncpy(dat->dat_d[line], editable, 2046);
			}
		}	
	}
	return 0;
}

